# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from ..core.pydantic_utilities import deep_union_pydantic_dicts, pydantic_v1
from .session_fact_rating_instruction import SessionFactRatingInstruction


class Session(pydantic_v1.BaseModel):
    classifications: typing.Optional[typing.Dict[str, str]] = None
    created_at: typing.Optional[str] = None
    deleted_at: typing.Optional[str] = None
    ended_at: typing.Optional[str] = None
    fact_rating_instruction: typing.Optional[SessionFactRatingInstruction] = None
    facts: typing.Optional[typing.List[str]] = None
    id: typing.Optional[int] = None
    metadata: typing.Optional[typing.Dict[str, typing.Any]] = None
    project_uuid: typing.Optional[str] = None
    session_id: typing.Optional[str] = None
    updated_at: typing.Optional[str] = None
    user_id: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    Must be a pointer to allow for null values
    """

    uuid_: typing.Optional[str] = pydantic_v1.Field(alias="uuid", default=None)

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults_exclude_unset: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        kwargs_with_defaults_exclude_none: typing.Any = {"by_alias": True, "exclude_none": True, **kwargs}

        return deep_union_pydantic_dicts(
            super().dict(**kwargs_with_defaults_exclude_unset), super().dict(**kwargs_with_defaults_exclude_none)
        )

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        populate_by_name = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
